// Copyright 2015, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Author: Zhiwei Zhang <zhiwei.zhang@saturn.uni-freiburg.de>

#ifndef _USERS_ZHANGZHIWEI_ZHIWEI_ZHANG_SIMULATIONTESTCLASS_H_
#define _USERS_ZHANGZHIWEI_ZHIWEI_ZHANG_SIMULATIONTESTCLASS_H_

#include <limits>

class SimulationTestClass {
 public:

  explicit SimulationTestClass(int min, int max, size_t quantity,
                               bool geo = false) {
    _min = min;
    _max = max;
    _quantity = quantity;
    _geo = geo;
  }

  void testEliasGammaEncodingVector() const;
  void testEliasGammaEncodingPointer() const;

  void testEliasDeltaEncodingVector() const;
  void testEliasDeltaEncodingPointer() const;

  void testGolombEncodingVector(
                    size_t M = std::numeric_limits<int>::max()) const;
  void testGolombEncodingPointer(
                    size_t M = std::numeric_limits<int>::max()) const;

  void testVariableByteEncodingVector() const;
  void testVariableByteEncodingPointer() const;

  void testSimple8bCode() const;
  void testSimple8bCodeOld() const;
  void testSimple8bCodeVector() const;

  void testSimple8bCodeNew1() const;
  void testSimple8bCodeNew2() const;

 private:
  size_t _quantity;
  int _max;
  int _min;

  // I use this value to test the case that there are lots of 0s in the gaplist
  bool _geo;
};

#endif  // _USERS_ZHANGZHIWEI_ZHIWEI_ZHANG_SIMULATIONTESTCLASS_H_
